<template>
    <v-list>
        <template v-if="loading">
            <v-list-item>
                <v-list-item-content>
                    <v-skeleton-loader
                        max-width="140"
                        max-height="140"
                        tile
                        type="image"
                    >
                    </v-skeleton-loader>
                </v-list-item-content>
                <v-list-item-content class="text-right">
                    <v-skeleton-loader type="list-item"></v-skeleton-loader>
                </v-list-item-content>
                <v-list-item-content class="text-right">
                    <v-skeleton-loader type="list-item"></v-skeleton-loader>
                </v-list-item-content>
                <v-list-item-content class="text-right">
                    <v-skeleton-loader type="list-item"></v-skeleton-loader>
                </v-list-item-content>
            </v-list-item>
        </template>
        <template
            v-else
            v-for="item in order.items"
        >
            <v-list-item>
                <v-list-item-avatar tile size="140">
                    <v-img contain :src="item.product.images[0].url"></v-img>
                </v-list-item-avatar>
                <v-list-item-content class="text-right">
                    <span class="subtitle-1">{{ item.product.name }}</span>
                </v-list-item-content>
                <v-list-item-content class="text-right" v-if="order.tracks.length > 0 && showItemHoldingTag && !isBusinessTypeShop">
                    <span class="subtitle-1">
                        <v-chip
                            class="ma-2"
                            text-color="white"
                            :color="itemStatus(item) === 'holding' ? 'primary' : 'green'"
                        >
                            {{ $t(itemStatus(item)) }}
                        </v-chip>
                    </span>
                </v-list-item-content>
                <v-list-item-content class="text-right">
                    <span class="subtitle-1">{{ item.variant.name }}</span>
                </v-list-item-content>
                <v-list-item-content class="text-right">
                    <span class="subtitle-1">x {{ item.quantity }}</span>
                </v-list-item-content>
            </v-list-item>
            <v-divider></v-divider>
        </template>
        <v-list-item>
            <v-list-item-content></v-list-item-content>
            <v-list-item-content class="text-right">
                <span class="subtitle-1">{{ $t('amount') }}</span>
            </v-list-item-content>
            <v-list-item-content class="text-right">
                <span class="text-uppercase subtitle-1">
                    {{ order.currency }}{{ order.amount | currency }}
                </span>
            </v-list-item-content>
        </v-list-item>
    </v-list>
</template>

<script>
    import OrderStatus from "../../../constants/order";
    import BusinessType from "../../../constants/businessType";

    export default {
        name: 'OrderItem',
        props: {
            loading: {
                type: Boolean,
                default: false
            },
            order: {
                type: Object,
                default: () => ({
                    items: [],
                    amount: 0,
                    currency: ''
                })
            }
        },
        methods:{
            itemStatus(item) {
                for(let i = 0; i < this.order.tracks.length; i++){
                    let itemStock = item.product.stocks
                    let track = this.order.tracks[i]
                    for (let x = 0; x < itemStock.length; x++){
                        let stock = itemStock[x]
                        if(stock.id === track.product_stock_id && !track.scanned_at) return "holding"
                        if(stock.id === track.product_stock_id && track.scanned_at) return "returned"
                    }
                }
            }
        },
        computed: {
            showItemHoldingTag() {
                return this.order.status.id === OrderStatus.COMPLETED ||
                    this.order.status.id === OrderStatus.DELIVERED ||
                    this.order.status.id === OrderStatus.PARTIAL_RETURNED
            },
            isBusinessTypeShop() {
                const shopBusinessType = this.order.business_type_id === BusinessType.SHOP;

                return shopBusinessType;
            },
        }
    }
</script>

<style scoped>

</style>
